 
      PROGRAM TZGEEV1
*
*     test for  PZGEEV1
*
      include 'mpif.h'
* parameters
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, ILWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 20, LWORK = 450, MAXN = 100,
**      PARAMETER         ( LDA = 20, LWORK = -1, MAXN = 100,
     $                   MAXPROCS = 16, NOUT =6, ZERO = 0.0D+0,
     $                   MONE = -1.0D+0, ILWORK = 1 )
*
* local scalars
      INTEGER            CTXT, I, IAM, INFO,
     $                   MYCOL, MYROW, N, NB, NPCOL, NPROCS, NPROW,
     $                   IA, JA
*
* local arrays
      INTEGER            DESCA( 9 ), IWORK( ILWORK )
      COMPLEX*16         A( LDA, LDA ),
     $                   W(20), WORK( LWORK ), WORK1( 7 )
**     $                   WORK( 60 ), WORK1( 7 )
*
* external subroutines
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PZMATINIT, PZLAPRNT,
     $                   PZGEEV1
*
* executable statements
*
*  
*
      N = 20
      NB = 7
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
*
* initialize of BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* initialize of BLACS'context and process grid
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*  if      ,
*  go to the end of program
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
* initialize descriptor of a matrix  A
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
* constraction of a matrix A
*
      CALL PZMATINIT( N, A, IA, JA, DESCA, INFO )
*
* print input data
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' input data '
*
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) ' matrix A'
      END IF
 9985 FORMAT( / 9I5 /)
*
      CALL PZLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
* compute all eigenvalues of a matrix A
*
      CALL PZGEEV1( N, A, IA, JA, DESCA, W, WORK, LWORK, INFO )
*
* print results
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) ' '
         WRITE( NOUT, FMT = * ) ' results '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9999 ) WORK(1)
         WRITE( NOUT, FMT = 9991 ) W
      END IF
*
      CALL BLACS_GRIDEXIT( CTXT )
*
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( ' WORK(1) = ', (D16.6,D16.6)// )
 9991 FORMAT( ' W '/, (D16.6,D16.6)/)
*
 9992 FORMAT( / 'A test for the subroutine PZGEEV1' )
 9998 FORMAT( / ' computing eigenvalues of matrix A,'
     $      ' here A - complex general matrix ',
     $      I2, ' * ', I2,',' /
     $       '      partisioned into ( ', I2, ' * ', I2,') - blocks' /)
 9997 FORMAT( / ' Run on ', I2, ' processes,',
     $       ' forming  process grid (', I2, ' * ', I2,')' /)
 9996 FORMAT( / '  INFO  = ', I6 /)
      STOP
      END
***
      SUBROUTINE PZMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT     A   
*
*   - 
*  - 
      INTEGER            IA, INFO, JA, N
*  - 
      INTEGER            DESCA( * )
      COMPLEX*16         A( * )
*  
      INTEGER            I, J
*
*  
      EXTERNAL           PZELSET
*
* executable statements
*
      INFO = 0
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 2 J = 1, N
      DO 1 I = 1, N
      CALL PZELSET( A, I, J, DESCA, (0.0D0, 0.0D0))
    1 CONTINUE
    2 CONTINUE
      DO 4 J = 1, N
      DO 3 I = 1, N
         IF( I.EQ.J ) THEN
            CALL PZELSET( A, I, J, DESCA, (1.0D0, 0.0D0))
         END IF
    3 CONTINUE
    4 CONTINUE
      J = N
      DO 5 I = 1, N
      CALL PZELSET( A, I, J, DESCA, DCMPLX(DBLE(I), 0.0D0))
    5 CONTINUE
      I = N
      DO 6 J = 1, N
      CALL PZELSET( A, I, J, DESCA, DCMPLX(DBLE(J), 0.0D0))
    6 CONTINUE
*
      RETURN
*
*     End of PZMATINIT
*
      END
